package webovyformular;

import java.applet.*;
import java.io.*;
import java.util.*;

import java.awt.*;
import java.awt.event.*;

import webovyformular.dat_typy.*;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 * Aplet pro vpoet funkc FIRST a FOLLOW a pro rozhodovn o vstupn
 * gramatice, zda je SLL(k).
 *
 * @author Michal Hanzelka
 * @version 1.0
 */


public class FormularApplet
    extends Applet {
  boolean isStandalone = false;
  BorderLayout borderLayout1 = new BorderLayout();
  private Label labelNeterminaly = new Label();
  private Label labelTerminaly = new Label();
  private Label labelPocatek = new Label();
  private Label labelPravidla = new Label();
  private TextField Pocatek = new TextField();
  private TextField Terminaly = new TextField();
  private TextField Neterminaly = new TextField();
  private TextArea Pravidla = new TextArea();
  private Label labelSllk = new Label();
  private Label labelFollowk = new Label();
  private Label labelFirstk = new Label();
  private TextField Sllk = new TextField();
  private TextField Firstk = new TextField();
  private TextField Followk = new TextField();
  private Label labelRetezec = new Label();
  private Label labelNeterminal = new Label();
  private TextField FirstRet = new TextField();
  private TextField FollowNet = new TextField();
  private Button bSll = new Button();
  private Button bFollow = new Button();
  private Button bFirst = new Button();
  private Label labelVysledek = new Label();
  private Button bVymazVysl = new Button();
  private Button bNacti = new Button();
  private Button bUloz = new Button();
  private Label Chyba = new Label();
  private Button bVymazGram = new Button();
  private TextArea Vysledky = new TextArea();
  private Button bRedukuj = new Button();
  private java.awt.Choice nabidka = new Choice();
  private java.awt.Button bNactiZDBS = new Button();

  private static HashSet<Character> oddelovace = new HashSet<Character> (); //oddelovace znaku
  private static String konecRadku; //znak oddelujici radky

  //konstruktor
  public FormularApplet() {
  }

  //inicializace apletu
  public void init() {
    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  //incicializace komponent
  private void jbInit() throws Exception {
    this.setLayout(null);

    Chyba.setFont(new java.awt.Font("Dialog", Font.PLAIN, 20));
    Chyba.setForeground(Color.red);
    Chyba.setBounds(new Rectangle(45, 8, 766, 32));

    labelNeterminaly.setText("Mnoina neterminl:");
    labelNeterminaly.setBounds(new Rectangle(45, 47, 120, 23));

    Neterminaly.setBackground(new Color(210, 250, 190));
    Neterminaly.setText("");
    Neterminaly.setBounds(new Rectangle(45, 73, 240, 23));

    labelTerminaly.setText("Mnoina terminl:");
    labelTerminaly.setBounds(new Rectangle(45, 99, 120, 23));

    Terminaly.setBackground(new Color(210, 250, 190));
    Terminaly.setText("");
    Terminaly.setBounds(new Rectangle(45, 125, 240, 23));

    labelPocatek.setText("Poten neterminl:");
    labelPocatek.setBounds(new Rectangle(45, 151, 120, 23));

    Pocatek.setBackground(new Color(210, 250, 190));
    Pocatek.setBounds(new Rectangle(45, 177, 60, 23));

    labelPravidla.setText("Mnoina pravidel:");
    labelPravidla.setBounds(new Rectangle(45, 203, 120, 23));

    Pravidla.setBackground(new Color(210, 250, 190));
    Pravidla.setBounds(new Rectangle(45, 229, 341, 245));

    bVymazGram.setBackground(new Color(85, 200, 15));
    bVymazGram.setFont(new java.awt.Font("Dialog", Font.BOLD, 11));
    bVymazGram.setLabel("Vyma gramatiku");
    bVymazGram.setBounds(new Rectangle(45, 477, 130, 23));
    bVymazGram.addActionListener(new FormularApplet_bVymazGram_actionAdapter(this));

    bRedukuj.setBackground(new Color(85, 200, 15));
    bRedukuj.setFont(new java.awt.Font("Dialog", Font.BOLD, 11));
    bRedukuj.setLabel("Redukuj gramatiku");
    bRedukuj.setBounds(new Rectangle(245, 177, 141, 23));
    bRedukuj.addActionListener(new FormularApplet_bRedukuj_actionAdapter(this));

    nabidka.setBackground(new Color(255, 255, 180));
    nabidka.setBounds(new Rectangle(45, 520, 200, 23));

    bNactiZDBS.setBackground(new Color(255, 255, 180));
    bNactiZDBS.setLabel("Nati z databze");
    bNactiZDBS.setBounds(new Rectangle(250, 518, 115, 23));
    bNactiZDBS.addActionListener(new FormularApplet_bNactiZDBS_actionAdapter(this));

    bNacti.setBackground(new Color(255, 255, 180));
    bNacti.setLabel("Nati ze souboru");
    bNacti.setBounds(new Rectangle(45, 550, 115, 23));
    bNacti.addActionListener(new FormularApplet_bNacti_actionAdapter(this));

    bUloz.setBackground(new Color(255, 255, 180));
    bUloz.setLabel("Ulo do souboru");
    bUloz.setBounds(new Rectangle(173, 550, 115, 23));
    bUloz.addActionListener(new FormularApplet_bUloz_actionAdapter(this));

    labelFirstk.setText("Zadej k:");
    labelFirstk.setBounds(new Rectangle(470, 47, 50, 23));

    labelRetezec.setText("etzec:");
    labelRetezec.setBounds(new Rectangle(538, 47, 70, 23));

    Firstk.setBackground(new Color(175, 220, 255));
    Firstk.setText("");
    Firstk.setBounds(new Rectangle(470, 73, 35, 23));

    FirstRet.setBackground(new Color(175, 220, 255));
    FirstRet.setText("");
    FirstRet.setBounds(new Rectangle(538, 73, 148, 23));

    bFirst.setBackground(new Color(175, 220, 255));
    bFirst.setFont(new java.awt.Font("Dialog", Font.BOLD, 11));
    bFirst.setLabel("FIRST(k)");
    bFirst.setBounds(new Rectangle(716, 72, 95, 23));
    bFirst.addActionListener(new FormularApplet_bFirst_actionAdapter(this));

    labelFollowk.setText("Zadej k:");
    labelFollowk.setBounds(new Rectangle(470, 99, 50, 23));

    labelNeterminal.setText("Neterminl:");
    labelNeterminal.setBounds(new Rectangle(538, 99, 70, 23));

    Followk.setBackground(new Color(125, 195, 255));
    Followk.setText("");
    Followk.setBounds(new Rectangle(470, 125, 35, 23));

    FollowNet.setBackground(new Color(125, 195, 255));
    FollowNet.setText("");
    FollowNet.setBounds(new Rectangle(538, 125, 60, 23));

    bFollow.setBackground(new Color(125, 195, 255));
    bFollow.setFont(new java.awt.Font("Dialog", Font.BOLD, 11));
    bFollow.setLabel("FOLLOW(k)");
    bFollow.setBounds(new Rectangle(716, 124, 95, 23));
    bFollow.addActionListener(new FormularApplet_bFollow_actionAdapter(this));

    labelSllk.setText("Zadej k:");
    labelSllk.setBounds(new Rectangle(470, 151, 50, 23));

    Sllk.setBackground(new Color(0, 180, 255));
    Sllk.setBounds(new Rectangle(470, 177, 35, 23));

    bSll.setBackground(new Color(0, 180, 255));
    bSll.setFont(new java.awt.Font("Dialog", Font.BOLD, 11));
    bSll.setLabel("SLL(k)");
    bSll.setBounds(new Rectangle(716, 176, 95, 23));
    bSll.addActionListener(new FormularApplet_bSll_actionAdapter(this));

    labelVysledek.setText("Vsledky:");
    labelVysledek.setBounds(new Rectangle(470, 203, 70, 23));

    Vysledky.setBackground(new Color(220, 240, 255));
    Vysledky.setEditable(true);
    Vysledky.setBounds(new Rectangle(470, 229, 341, 245));

    bVymazVysl.setBackground(new Color(175, 220, 255));
    bVymazVysl.setFont(new java.awt.Font("Dialog", Font.BOLD, 11));
    bVymazVysl.setLabel("Vyma vsledky");
    bVymazVysl.setBounds(new Rectangle(470, 477, 130, 23));
    bVymazVysl.addActionListener(new FormularApplet_bVymazVysl_actionAdapter(this));

    this.setBackground(Color.white);
    this.add(Chyba);
    this.add(labelNeterminaly);
    this.add(labelTerminaly);
    this.add(labelPocatek);
    this.add(labelPravidla);
    this.add(Neterminaly);
    this.add(Terminaly);
    this.add(Pocatek);
    this.add(Pravidla);
    this.add(bVymazGram);
    this.add(bRedukuj);
    this.add(nabidka);
    this.add(bNacti);
    this.add(bUloz);
    this.add(labelFirstk);
    this.add(labelRetezec);
    this.add(labelFollowk);
    this.add(labelNeterminal);
    this.add(labelSllk);
    this.add(labelVysledek);
    this.add(Firstk);
    this.add(FirstRet);
    this.add(bFirst);
    this.add(Followk);
    this.add(FollowNet);
    this.add(bFollow);
    this.add(Sllk);
    this.add(bSll);
    this.add(Vysledky);
    this.add(bVymazVysl);
    this.add(bNactiZDBS);

    /*naten jmen soubor ze serveru do nabidky */
    try {

      InputStreamReader isr;
      BufferedReader br;
      String radek;

                      //znaky, kterymi nesmi zacinat jmena souboru v OS Windows
      HashSet<Character> IlegalStartWin = new HashSet<Character> ();
      IlegalStartWin.add('<');
      IlegalStartWin.add('>');
      IlegalStartWin.add('?');
      IlegalStartWin.add('|');
      IlegalStartWin.add('*');
      IlegalStartWin.add(' ');
      IlegalStartWin.add('/');
      IlegalStartWin.add('\\');
      IlegalStartWin.add(':');
      IlegalStartWin.add('"');

      isr = new InputStreamReader(this.getClass().
                                  getResourceAsStream("../gramatiky/"));
      br = new BufferedReader(isr);
      int i, j;

      /*InputStream nemus bt "ist" seznam soubor, proto je v nm teba
       jmna soubor hledat; pedpokldm, e na kadm dku je maximln jedno
       jmno souboru */
      while ( (radek = br.readLine()) != null) {
        j = radek.indexOf(".txt");
        i = j;
        if (i > -1) {
          i--;
          while ( (i > -1) && (!IlegalStartWin.contains(radek.charAt(i)))) {
            i--;
          }
          i++;
          if (i < j) {
            this.nabidka.addItem(radek.substring(i, j));
          }

        }
      }
    }
    catch (IOException ioe) {
      this.Chyba.setText("IO chyba pri spojeni se serverem.");
    }

    /*nastaven znak, kter jsou pouity jako oddlovae jmen a pravidel v gramatice*/
    this.oddelovace.add(' ');
    this.oddelovace.add(',');
    this.oddelovace.add(';');
    this.oddelovace.add('|');
    this.oddelovace.add('-');
    this.oddelovace.add(':');
    this.oddelovace.add('>');

    /*nastaven znaku ukonujc dek*/
    this.konecRadku = System.getProperty("line.separator");

  } // konec inicializace

  public String getAppletInfo() {
    return "Webovy formular pro vypocet funkci first a follow";
  }

  /* vrac String obsaen v textov komponent */
  private String prectiText(TextComponent textComp) throws
      ParamPrazdnyStringException {
    String text = textComp.getText().trim();
    if (!text.trim().equals("")) {
      return text;
    }
    else {
      throw new ParamPrazdnyStringException();
    }
  }

  /* rozdeli vstupni String do casti podle oddelovacu */
  private ArrayList<String> rozdel(String str) {
    ArrayList<String> seznam_stringu = new ArrayList<String> ();
    String substr = "";
    int i;

    str = str.trim();
    for (i = 0; i < str.length(); i++) {
      if (!oddelovace.contains(str.charAt(i))) {
        substr += str.charAt(i);
      }
      else {
        if (!substr.equals("")) {
          seznam_stringu.add(substr);
          substr = "";
        }
      }
    }
    if (!substr.equals("")) {
      seznam_stringu.add(substr);
    }
    return seznam_stringu;
  }

  /* pevede String se jmny symbol na mnoinu obsahujc symboly danho typu */
  private HashSet<Znak> toMnozinaZnaku(String str, byte typ) throws
      PrefixEpsilonuException {

    HashSet<Znak> mnozina_znaku = new HashSet<Znak> ();
    ArrayList<String> pole_str;
    Znak pomZn;
    pole_str = this.rozdel(str);

    for (String aktStr : pole_str) {
      aktStr = aktStr.trim();
      if (!aktStr.equals("")) {
        try {
          pomZn = new Znak(aktStr, typ);
          mnozina_znaku.add(pomZn);
        }
        catch (ParamPrazdnyStringException ex) { //toto nenastane !!!
          ex.printStackTrace();
        }
      }
    }
    return mnozina_znaku;
  }

  /* z obsahu formule vytvo objekt typu Gramatika*/
  private Gramatika nactiGramatiku() {

    HashSet<Znak> neterm;
    HashSet<Znak> term;
    HashMap<Znak, HashSet<ArrayList<Znak>>> prav =
        new HashMap<Znak, HashSet<ArrayList<Znak>>> ();
    Znak poc;
    Gramatika gram;

    this.Chyba.setText("");

    /* natn mnoiny neterminl */
    try {
      String netermstr = prectiText(Neterminaly);
      neterm = this.toMnozinaZnaku(netermstr, (byte) 2);

      for (Znak aktNeterm1 : neterm) {
        for (Znak aktNeterm2 : neterm) {
          if ( (aktNeterm1 != aktNeterm2) &&
              (aktNeterm1.toString().startsWith(aktNeterm2.toString()))) {
            this.Chyba.setText("Chyba: jmno neterminlu \"" + aktNeterm2 +
                               "\" je " + "prefixem jmna neterminlu \"" +
                               aktNeterm1 + "\".");
            return null;
          }
        }
      }
    }
    catch (ParamPrazdnyStringException ex) {
      this.Chyba.setText("Chyba: mnoina neterminl je przdn");
      return null;
    }
    catch (PrefixEpsilonuException peex) {
      this.Chyba.setText("Chyba: jmno nkterho neterminlu je prefixem \"" +
                         Znak.jmenoEps +
                         "\", co jmno vyhrazen znaku epsilon.");
      return null;
    }

    /* natn mnoiny terminl */
    try {
      String termstr = prectiText(Terminaly);
      term = this.toMnozinaZnaku(termstr, (byte) 1);

      for (Znak aktTerm1 : neterm) {
        for (Znak aktTerm2 : neterm) {
          if ( (aktTerm1 != aktTerm2) &&
              (aktTerm1.toString().startsWith(aktTerm2.toString()))) {
            this.Chyba.setText("Chyba: jmno terminlu \"" + aktTerm2 +
                               "\" je " + "prefixem jmna terminlu \"" +
                               aktTerm1 + "\".");
            return null;
          }
        }
      }

    }
    catch (ParamPrazdnyStringException ex) {
      this.Chyba.setText("Chyba: mnoina terminl je przdn");
      return null;
    }
    catch (PrefixEpsilonuException peex) {
      this.Chyba.setText("Chyba: jmno nkterho terminlu je prefixem \"" +
                         Znak.jmenoEps +
                         "\", co jmno vyhrazen znaku epsilon.");
      return null;
    }

    /* kontrola prefix jmen neterminl a terminl */
    for (Znak aktNeterm : neterm) {
      for (Znak aktTerm : term) {
        if (aktNeterm.getJmeno().equals(aktTerm.getJmeno())) {
          this.Chyba.setText("Chyba: \"" + aktNeterm.getJmeno() +
                             "\" je jmno neterminlu i terminlu.");
          return null;
        }
        else {
          if (aktNeterm.toString().startsWith(aktTerm.toString())) {
            this.Chyba.setText("Chyba: jmno terminlu \"" + aktTerm +
                               "\" je prefixem jmna neterminlu \"" +
                               aktNeterm + "\".");
            return null;
          }
          else
          if (aktTerm.toString().startsWith(aktNeterm.toString())) {
            this.Chyba.setText("Chyba: jmno neterminlu \"" + aktNeterm +
                               "\" je prefixem jmna terminlu \"" +
                               aktTerm + "\".");
            return null;
          }
        }
      }
    }

    /* natn potku */
    try {
      poc = new Znak(prectiText(Pocatek), (byte) 2);
      if (neterm.contains(poc) == false) {
        this.Chyba.setText("Chyba: poten neterminl " + poc.getJmeno() +
                           " nen v mnoin neterminl.");
        return null;
      }
    }
    catch (ParamPrazdnyStringException ex) {
      this.Chyba.setText("Chyba: nen zadn poten neterminl");
      return null;
    }
    catch (PrefixEpsilonuException peex) {
      this.Chyba.setText("Chyba: jmno potenho neterminlu je prefixem \"" +
                         Znak.jmenoEps +
                         "\", co jmno vyhrazen znaku epsilon.");
      return null;
    }

    /* natn pravidel */
    int i = 0;
    int j; //index v aktualnim radku

    boolean je_neterm = false; //na leve strane radku je neterminal

    try {
      String pravStr = prectiText(Pravidla);
      String[] radky = pravStr.split(this.konecRadku);

      for (String aktRadek : radky) {
        aktRadek = aktRadek.trim();
        i++; //cislo radku
        je_neterm = false;

        if (!aktRadek.equals("")) {
          j = 0;
          while (j < aktRadek.length() && //pruchod k prvnimu oddelovaci
                 !this.oddelovace.contains(aktRadek.charAt(j))) {
            j++;
          }
          String levaStrana = aktRadek.substring(0, j); //od zacatku radku
                                                        //k prvnimu oddelovaci

          for (Znak aktNeterm : neterm) {
            if (levaStrana.equals(aktNeterm.toString())) { //hledam neterminal
                                                           //na leve strane
              je_neterm = true;
              while (j < aktRadek.length() && //preskoce oddelovacu
                     this.oddelovace.contains(aktRadek.charAt(j))) {
                j++;
              }
              if ( (j >= aktRadek.length())) { //jsem-li na konci, chybi pravidla
                this.Chyba.setText("Chyba: neterminl " + aktNeterm +
                                   " nem zadna pravidla");
                return null;
              }
              else {
                ArrayList<String> seznamPravidelStr = //zbytek radku jsou pravidla
                    this.rozdel(aktRadek.substring(j));

                HashSet<ArrayList<Znak>> aktNetermPravidla =
                    new HashSet<ArrayList<Znak>> ();

                try { //pevod String na ArrayList<Znak>
                  for (String aktPravStr : seznamPravidelStr) {

                    ArrayList<Znak> aktPravidlo =
                        Retezec.toRetezecZnaku(neterm, term, aktPravStr);
                    aktNetermPravidla.add(aktPravidlo);
                  }
                }
                catch (ZnakyNerozeznanyException znex) {
                  this.Chyba.setText("Chyba: v pravidlech neterminlu "
                                     + aktNeterm +
                                     " jsou znaky, kter nejsou ani " +
                                     "neterminly ani terminly");
                  return null;
                }

                Set netermSPravidly = prav.keySet(); //neterminaly s jiz vytvorenymi pravidly
                if (!netermSPravidly.contains(aktNeterm)) {
                  prav.put(aktNeterm, aktNetermPravidla); //vlozeni pravidla
                }
                else { //neterminal uz ma definovana pravidla
                  this.Chyba.setText("Chyba: pro neterminl " + aktNeterm +
                                     " je zadno vc mnoin pravidel.");
                  return null;
                }
              }
              break; //u netestuji dal neterminl zda je na lev stran
            }

          } //konec hledn neterminlu na lev stran
          if (je_neterm == false) {
            this.Chyba.setText("Chyba: " + i + ".dek mnoiny pravidel " +
                               "nem na lev stran neterminl.");
            return null;
          }
        }
      }
      HashSet<Znak> neterm_bez_pravidel = new HashSet<Znak> (neterm);
      neterm_bez_pravidel.removeAll(prav.keySet());
      if (!neterm_bez_pravidel.isEmpty()) {
        Iterator itn = neterm_bez_pravidel.iterator();
        this.Chyba.setText("Chyba: neterminl " + (Znak) itn.next() +
                           " nem definovan pravidla.");
        return null;

      }
    }
    catch (ParamPrazdnyStringException ex) {
      this.Chyba.setText("Chyba: mnoina pravidel je przdn");
      System.err.print(ex.getStackTrace());
      return null;
    }

    gram = new Gramatika(neterm, term, prav, poc);

    return gram;
  }

  /* redukuje gramatiku zapsanou ve formuli */
  protected void bRedukuj_actionPerformed(ActionEvent e) {

    Gramatika g = nactiGramatiku();
    Gramatika gRed;

    if (!g.equals(null)) {

      gRed = g.redukuj();

      /*vytvoreni Stringu z gramatiky pro zapis zpet do formulare */
      String n = "";
      for (Iterator itn = gRed.getNeterminaly().iterator(); itn.hasNext(); ) {
        n += (Znak) itn.next();
        if (itn.hasNext()) {
          n += ", ";
        }
      }

      String t = "";
      for (Iterator itt = gRed.getTerminaly().iterator(); itt.hasNext(); ) {
        t += (Znak) itt.next();
        if (itt.hasNext()) {
          t += ", ";
        }
      }

      String p = "";
      HashSet<ArrayList<Znak>> aktPravidla;
      HashMap<Znak, HashSet<ArrayList<Znak>>> pravidla = gRed.getPravidla();
      Znak pocatek = gRed.getPocatek();

      if (pravidla.containsKey(pocatek)) { //pravidla pocatecniho neterminlu se vypisuji prvni
        p += pocatek + " -> ";
        aktPravidla = pravidla.get(pocatek);
        for (Iterator itP = aktPravidla.iterator(); itP.hasNext(); ) {
          p += Retezec.toString( (ArrayList<Znak>) itP.next());
          if (itP.hasNext()) {
            p += " | ";
          }
        }
        p += konecRadku;
      }
      for (Iterator itN = pravidla.keySet().iterator(); itN.hasNext(); ) {
        Znak aktNeterm = (Znak) itN.next();
        if (aktNeterm != pocatek) {
          p += aktNeterm + " -> ";
          aktPravidla = (HashSet<ArrayList<Znak>>) pravidla.get(aktNeterm);

          for (Iterator itP = aktPravidla.iterator(); itP.hasNext(); ) {
            p += Retezec.toString( (ArrayList<Znak>) itP.next());

            if (itP.hasNext()) {
              p += " | ";
            }
          }
          if (itN.hasNext()) {
            p += "\n";
          }
        }
      }

      this.Neterminaly.setText(n);  //zredukovane terminaly
      this.Terminaly.setText(t);    //zredukovane neterminaly
      this.Pravidla.setText(p);     //redukovana nebo jen zformatovana pravidla
      this.Pocatek.setText(gRed.getPocatek().toString()); //sice by se nemel
                                                          //zmenit, ale co kdyby :)

      if (gRed.equals(g)) {
        this.Vysledky.append("Gramatika ji je redukovan.\n");
      }
      else {
        this.Vysledky.append("Gramatika byla redukovna.\n");
      }
    }
  }

  /* vypot FIRST */
  protected void bFirst_actionPerformed(ActionEvent e) {
    Gramatika g = null;
    ArrayList<Znak> ret = null;
    HashSet<ArrayList<Znak>> first = null;
    int k;

    g = nactiGramatiku();
    if (!g.equals(null)) {
      try {
        String retStr = this.FirstRet.getText();
        String kStr = prectiText(Firstk);
        k = Integer.valueOf(kStr).intValue();

        ret = Retezec.toRetezecZnaku(g.getNeterminaly(),
                                     g.getTerminaly(),
                                     retStr);
        first = Retezec.first(ret, g.getPravidla(), k);
        this.Vysledky.append("FIRST(" + Retezec.toString(ret) + ")_" + k +
                             " = " + Retezec.toString(first) + "\n");

      }
      catch (ParamPrazdnyStringException ppsex) {
        this.Chyba.setText("Chyba: nen zadn parametr k nebo vstupn " +
                           "etzec.");
      }
      catch (ZnakyNerozeznanyException znex) {
        this.Chyba.setText("Chyba: ve vstupnm etzci jsou znaky, kter " +
                           "nejsou ani neterminly ani terminly.");
      }
      catch (NumberFormatException nfex) {
        this.Chyba.setText("Chyba: parametrem k nen cel slo.");
      }
      catch (NekladnyParamException npex) {
        this.Chyba.setText("Chyba: parametrem k nen kladn slo.");
      }
    }
  }

  /* vypot FOLLOW */
  protected void bFollow_actionPerformed(ActionEvent e) {
    Gramatika g;
    String jmenoNeterm;
    Znak neterm = null;
    HashSet<ArrayList<Znak>> follow;
    int k;

    g = nactiGramatiku();
    if (!g.equals(null)) {
      try {
        String kStr = prectiText(Followk);
        k = Integer.valueOf(kStr).intValue();
        jmenoNeterm = prectiText(FollowNet);

        for (Znak aktNeterm : g.getNeterminaly()) {
          if (aktNeterm.getJmeno().equals(jmenoNeterm)) {
            neterm = aktNeterm;
            break;
          }
        }
        if (neterm != null) {
          follow = Retezec.follow(neterm, g, k);
          this.Vysledky.append("FOLLOW(" + neterm.getJmeno() + ")_" + k +
                               " = " + Retezec.toString(follow) + "\n");
        }
        else {
          this.Chyba.setText("Chyba: neterminl \"" + jmenoNeterm +
                             "\" nen v mnoin neterminl.");
          return;
        }

      }
      catch (ParamPrazdnyStringException ppsex) {
        this.Chyba.setText("Chyba: nen zadn parametr k nebo neterminl.");
      }
      catch (NumberFormatException nfex) {
        this.Chyba.setText("Chyba: parametrem k nen cel slo.");
      }
      catch (NekladnyParamException npex) {
        this.Chyba.setText("Chyba: parametrem k nen kladn slo.");
      }
    } //if
  }

  /* rozhodne, zda je gramatika SLL(k) */
  protected void bSll_actionPerformed(ActionEvent e) {
    Gramatika g;
    int k;
    String sloveso;

    g = this.nactiGramatiku();
    if (!g.equals(null)) {
      Gramatika g_red = g.redukuj();
      if (g.equals(g_red)) {

        try {
          String kStr = prectiText(Sllk);
          k = Integer.valueOf(kStr).intValue();

          sloveso = (g_red.isSll(k)) ? "je" : "neni";
          this.Vysledky.append("Zadan gramatika " + sloveso + " SLL_" + k +
                               ".\n");

        }
        catch (ParamPrazdnyStringException ppsex) {
          this.Chyba.setText("Chyba: nen zadn parametr k.");
        }
        catch (NumberFormatException nfex) {
          this.Chyba.setText("Chyba: parametrem k nen cel kladn slo.");
        }

        catch (NekladnyParamException npex) {
          this.Chyba.setText("Chyba: parametrem k nen kladn slo.");
        }
      }
      else {
        this.Chyba.setText("Chyba: zadan gramatika nen redukovan.");
      }
    }
  }

  //nate do formule obsah souboru, ke ktermu je zadan cesta (lokln nebo na serveru)
  private void NactiSouborDoFormulare(String cesta) {

    BufferedReader br;
    FileReader fr = null;
    String radek;

    try {
      if (cesta.charAt(0) == '.') {              //soubor je na serveru
        InputStreamReader isr = new InputStreamReader(this.getClass().
            getResourceAsStream(cesta));
        br = new BufferedReader(isr);
      }
      else {                                     //soubor je na lokalnim disku
        fr = new FileReader(new File(cesta));
        br = new BufferedReader(fr);
      }

      Neterminaly.setText(br.readLine().trim());
      Terminaly.setText(br.readLine().trim());
      Pocatek.setText(br.readLine().trim());
      Pravidla.setText("");
      while ( (radek = br.readLine()) != null) {
        Pravidla.append(radek + konecRadku);
      }

    }
    catch (FileNotFoundException fnfex) {
      this.Chyba.setText("Chyba: soubor nenalezen nebo nemte prvo pro ten.");
    }
    catch (IOException ioex) {
      this.Chyba.setText("Chyba pi ten ze souboru.");
    }
    finally {
      if (fr != null) {
        try {
          fr.close();
        }
        catch (IOException ex) {
          Chyba.setText("Chyba pi zavrn souboru.");
        }
      }
    }
  }

  /* nate gramatiku ze souboru z loklnho disku klienta  */
  protected void bNacti_actionPerformed(ActionEvent e) {

    String cesta;

    Frame parent = new Frame();
    FileDialog fd = new FileDialog(parent, "Nati soubor", FileDialog.LOAD);
    fd.setFilenameFilter(new FiltrSouboru(".txt"));
    fd.setVisible(true);

    cesta = fd.getDirectory() + fd.getFile();
    if (fd.getFile() != null) {
      this.NactiSouborDoFormulare(cesta);
    }
  }

  /* ulo gramatiku na disk klienta*/
  protected void bUloz_actionPerformed(ActionEvent e) {

    String konecRadky = System.getProperty("line.separator");
    String cesta;

    Frame parent = new Frame();
    FileDialog fd = new FileDialog(parent, "Ulo soubor", FileDialog.SAVE);
    fd.setVisible(true);
    cesta = fd.getDirectory() + fd.getFile();

    if (fd.getFile() != null) {
      File file = new File(cesta);

      if (!file.exists()) {
        try {
          file.createNewFile();
        }
        catch (IOException ioex) {
          this.Vysledky.setText("Vznikla I/O chyba pi vytven souboru");
        }
      }

      FileWriter zapis = null;
      try {

        zapis = new FileWriter(file);

        zapis.write(this.Neterminaly.getText() + konecRadky);
        zapis.write(this.Terminaly.getText() + konecRadky);
        zapis.write(this.Pocatek.getText() + konecRadky);
        zapis.write(this.Pravidla.getText() + konecRadky);

        this.Vysledky.append("Gramatika byla uloena.\n");

      }
      catch (FileNotFoundException ex) {
        this.Chyba.setText(
            "Chyba: soubor nenalezen nebo nemte prvo pro zpis.");
      }
      catch (IOException ex) {
        this.Chyba.setText("Chyba pi zpisu do souboru.");
      }
      finally {
        if (zapis != null) {
          try {
            zapis.close();
          }
          catch (IOException ex) {
            Chyba.setText("Chyba pi zavrn souboru.");
          }
        }
      }
    }
  }

  /* nate vybranou gramatiku ze serveru do formule */
  protected void bNactiZDBS_actionPerformed(ActionEvent e) {

    String cesta = "../gramatiky/" + this.nabidka.getSelectedItem() + ".txt";
    this.NactiSouborDoFormulare(cesta);
  }

  /* vymae vstupn pole Neterminaly,Terminaly,Pocatek,Pravidla */
  protected void bVymazGram_actionPerformed(ActionEvent e) {
    this.Neterminaly.setText("");
    this.Terminaly.setText("");
    this.Pocatek.setText("");
    this.Pravidla.setText("");
    this.Chyba.setText("");
  }

  /* vymae obsah pole Vysledky */
  protected void bVymazVysl_actionPerformed(ActionEvent e) {
    this.Vysledky.setText("");
    this.Chyba.setText("");
  }
} //konec tdy FormularApplet

/*dle jsou actionAdaptery tlatek */
class FormularApplet_bNactiZDBS_actionAdapter
    implements java.awt.event.ActionListener {
  private FormularApplet adaptee;
  FormularApplet_bNactiZDBS_actionAdapter(FormularApplet adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(java.awt.event.ActionEvent e) {
    adaptee.bNactiZDBS_actionPerformed(e);
  }
}

class FormularApplet_bSll_actionAdapter
    implements ActionListener {
  private FormularApplet adaptee;
  FormularApplet_bSll_actionAdapter(FormularApplet adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.bSll_actionPerformed(e);
  }
}

class FormularApplet_bUloz_actionAdapter
    implements ActionListener {
  private FormularApplet adaptee;
  FormularApplet_bUloz_actionAdapter(FormularApplet adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.bUloz_actionPerformed(e);
  }
}

class FormularApplet_bNacti_actionAdapter
    implements ActionListener {
  private FormularApplet adaptee;
  FormularApplet_bNacti_actionAdapter(FormularApplet adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.bNacti_actionPerformed(e);
  }
}

class FormularApplet_bFollow_actionAdapter
    implements ActionListener {
  private FormularApplet adaptee;
  FormularApplet_bFollow_actionAdapter(FormularApplet adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.bFollow_actionPerformed(e);
  }
}

class FormularApplet_bFirst_actionAdapter
    implements ActionListener {
  private FormularApplet adaptee;
  FormularApplet_bFirst_actionAdapter(FormularApplet adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.bFirst_actionPerformed(e);
  }
}

class FormularApplet_bRedukuj_actionAdapter
    implements ActionListener {
  private FormularApplet adaptee;
  FormularApplet_bRedukuj_actionAdapter(FormularApplet adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.bRedukuj_actionPerformed(e);
  }
}

class FormularApplet_bVymazGram_actionAdapter
    implements ActionListener {
  private FormularApplet adaptee;
  FormularApplet_bVymazGram_actionAdapter(FormularApplet adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.bVymazGram_actionPerformed(e);
  }
}

class FormularApplet_bVymazVysl_actionAdapter
    implements ActionListener {
  private FormularApplet adaptee;
  FormularApplet_bVymazVysl_actionAdapter(FormularApplet adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.bVymazVysl_actionPerformed(e);
  }
}
